#include "X3D_Cylinder.h"

namespace X3DTK {
namespace X3D {

Cylinder::Cylinder()
: X3DGeometryNode()
{
  define(Recorder<Cylinder>::getTypeName("Cylinder", "Geometry3D"));
  
  define(Recorder<Cylinder, SFBool>::getAttribute("bottom", &Cylinder::_bottom, true));
  define(Recorder<Cylinder, SFFloat>::getAttribute("radius", &Cylinder::_radius, 1.0f));
  define(Recorder<Cylinder, SFFloat>::getAttribute("height", &Cylinder::_height, 2.0f));
  define(Recorder<Cylinder, SFBool>::getAttribute("side", &Cylinder::_side, true));
  define(Recorder<Cylinder, SFBool>::getAttribute("top", &Cylinder::_top, true));
}

Cylinder::~Cylinder()
{
}

void Cylinder::setBottom(const SFBool &bottom)
{
  _bottom = bottom;
}

void Cylinder::setRadius(const SFFloat &radius)
{
  _radius = radius;
}

void Cylinder::setHeight(const SFFloat &height)
{
  _height = height;
}

void Cylinder::setSide(const SFBool &side)
{
  _side = side;
}

void Cylinder::setTop(const SFBool &top)
{
  _top = top;
}

}
}
