#include "X3D_FillProperties.h"

namespace X3DTK {
namespace X3D {

FillProperties::FillProperties()
: X3DAppearanceChildNode()
{
  define(Recorder<FillProperties>::getTypeName("FillProperties", "Shape"));
  
  define(Recorder<FillProperties, SFString>::getAttribute("fillStyle", &FillProperties::_fillStyle, ""));
  define(Recorder<FillProperties, SFInt32>::getAttribute("hatchStyle", &FillProperties::_hatchStyle, 1));
  define(Recorder<FillProperties, SFColor>::getAttribute("hatchColor", &FillProperties::_hatchColor, SFColor(1.0f, 1.0f, 1.0f)));
}

FillProperties::~FillProperties()
{
}

void FillProperties::setFillStyle(const SFString &fillStyle)
{
  _fillStyle = fillStyle;
}

void FillProperties::setHatchStyle(const SFInt32 &hatchStyle)
{
  _hatchStyle = hatchStyle;
}

void FillProperties::setHatchColor(const SFColor &hatchColor)
{
  _hatchColor = hatchColor;
}

}
}
