#include "X3D_BBoxUpdaterCoreVisitor.h"
#include "X3D_X3DNode.h"
#include "X3D_Scene.h"
#include "BBox.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

BBoxUpdaterCoreVisitor::BBoxUpdaterCoreVisitor()
: CoreVisitor()
{
  // WalkOn functions.
  define(Recorder<X3DNode>::getWalkOnFunction(&BBoxUpdaterCoreVisitor::walkOnX3DNode));

  // Leave functions.
  define(Recorder<Scene>::getLeaveFunction(&BBoxUpdaterCoreVisitor::leaveScene));
}

bool BBoxUpdaterCoreVisitor::walkOnX3DNode(X3DNode *, SFNode) 
{
  return false;
}

void BBoxUpdaterCoreVisitor::leaveScene(Scene *S) 
{
  BBoxUpdaterStateVariables *stateVariables = Singleton<BBoxUpdaterStateVariables>::getInstance();

  BBox *BB = stateVariables->getBBox(S);
  if (BB == 0)
  {
    MFNode children = S->getChildren();
    for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    {
      X3DBoundedObject *BO = dynamic_cast<X3DBoundedObject *>(*it);
      if (BO != 0)
        stateVariables->addBBoxToMergeList(BBox(BO->getBBoxCenter(), BO->getBBoxSize()));
    }
    BB = new BBox(stateVariables->mergeBBox()); 
    stateVariables->addBBox(S, BB);
    
    //updating the BBox attributes.
    S->setBBoxCenter(BB->getCenter());
    S->setBBoxSize(BB->getSize());
  }
}

}
}
