#include "X3D_CoordMerger.h"
#include "X3D_CoordMergerRenderingVisitor.h"
#include "DFSGraphTraversal.h"
#include "X3D_X3DNode.h"
#include "X3D_Scene.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

CoordMerger::CoordMerger()
: X3DOnePassProcessor()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new CoordMergerRenderingVisitor());
}

CoordMerger::~CoordMerger()
{
  Singleton<CoordMergerStateVariables>::removeInstance();
}

void CoordMerger::merge(Scene *S)
{
  merge(static_cast<X3DNode *>(S));
  
  S->getProcessHistory().addEntry("X3D::CoordMerger");
}

void CoordMerger::merge(X3DNode *N)
{
  traverse(N);
  Singleton<CoordMergerStateVariables>::getInstance()->finish();
}


}
}
