#include "X3D_InlineLoaderStateVariables.h"

#include <algorithm>
#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

InlineLoaderStateVariables::InlineLoaderStateVariables()
: StateVariables(), _hasInline(false)
{
}

InlineLoaderStateVariables::~InlineLoaderStateVariables()
{
}

void InlineLoaderStateVariables::init()
{
  _nodeStack.push_front(0);
}

void InlineLoaderStateVariables::finish()
{
  _nodeStack.clear();
  _hasInline = (!_visitedNodeList.empty());
  _visitedNodeList.clear();
}

void InlineLoaderStateVariables::addVisitedNode(SFNode N)
{
  _visitedNodeList.push_back(N);
}

void InlineLoaderStateVariables::pushNode(SFNode N)
{
  _nodeStack.push_front(N);
}

void InlineLoaderStateVariables::popNode()
{
  _nodeStack.pop_front();
}

void InlineLoaderStateVariables::setForce(bool force)
{
  _force = force;
}

void InlineLoaderStateVariables::setPath(const SFString &path)
{
  _path = path;
}

}
}
